import { j as s } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as Z, useState as B, useMemo as f, useEffect as I } from "react";
import { isMobile as z } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { Table as S, Skeleton as ss } from "antd";
import es from "../../BitzDrawer/index.mjs";
import ls from "../../BitzLoadMore/index.mjs";
import ns from "../../BitzPagination/index.mjs";
import is from "../../BitzNoData/index.mjs";
import rs, { TableContext as os } from "../Store/index.mjs";
import ts from "../TableSkeleton/index.mjs";
import { columnSort as as, genColumnKey as p } from "../Store/utils/index.mjs";
import "./index.less.mjs";
import xs from "../../../node_modules/lodash-es/at.mjs";
const cs = ({
  tableItemEmit: h = () => {
  },
  showPagination: L = !0,
  dataSource: e = [],
  total: d = 0,
  columns: a,
  loading: x = !1,
  skeletonNum: T = 2,
  skeletonRender: j,
  skeletonRowNum: C = 4,
  skeletonRowsWidth: y = ["35%", "100%", "100%", "60%"],
  tableOperationEmit: M = () => {
  },
  mobileLoadEmit: k = () => {
  },
  mobileRefreshEmit: u = () => {
  },
  operations: E = [],
  enableControlPage: K,
  pagination: D,
  paginationEmit: F = () => {
  },
  mobilePageHeight: O = 500,
  mobileCancelText: P = "取消",
  noDataTitle: $,
  noDataImg: _,
  color: A,
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  size: m,
  showTableTool: H = !0,
  tableAction: V,
  tableToolbar: W,
  resetPage: q,
  ...t
}) => {
  const o = Z(os), [G, b] = B(!1), [J, Q] = B({}), R = f(() => (e == null ? void 0 : e.length) == d && (e == null ? void 0 : e.length) > 0, [e, d]), U = (l) => {
    b(!0), Q(l), h(l);
  }, v = () => {
    b(!1);
  }, X = (l) => {
    b(!1), M(l.type, J);
  }, c = f(() => {
    const l = (r) => r.map((i) => {
      const Y = p(
        (i == null ? void 0 : i.key) || (i == null ? void 0 : i.dataIndex),
        i.index
      ), w = o.columnList[Y];
      return w && w.show === !1 ? !1 : i.children ? {
        ...i,
        children: l(i.children)
      } : i;
    }).filter(Boolean);
    return l(a).sort(as(o.columnList));
  }, [o.columnList, a]), N = f(() => {
    if (t != null && t.rowSelection)
      return {
        ...t.rowSelection,
        fixed: "left",
        columnWidth: 52
      };
  }, [t.rowSelection]);
  I(() => {
    if (a && a.length > 0) {
      const l = a.map(
        (n) => (
          // @ts-ignore
          p((n == null ? void 0 : n.key) ?? (n == null ? void 0 : n.dataIndex), n == null ? void 0 : n.dataIndex)
        )
      );
      o.setSortKeyColumns(l);
    }
  }, [a]);
  const g = f(() => `${m ?? (o == null ? void 0 : o.tableSize) ?? "lg"}BitzTable`, [m, o.tableSize]);
  return /* @__PURE__ */ s.jsxs("div", { className: "bitzTableBlock", children: [
    !z && /* @__PURE__ */ s.jsxs("div", { className: `bitzTableContainer ${g}`, children: [
      H && /* @__PURE__ */ s.jsxs("div", { className: "bitzTableToolbarBlock", children: [
        V,
        W
      ] }),
      x ? /* @__PURE__ */ s.jsx(
        ts,
        {
          columns: c,
          dataLength: e == null ? void 0 : e.length,
          scroll: t.scroll ?? { x: 1e3 },
          rowSelection: N,
          className: g
        }
      ) : /* @__PURE__ */ s.jsx(
        S,
        {
          columns: c,
          dataSource: e,
          loading: x,
          size: "large",
          pagination: !1,
          rowSelection: N,
          scroll: { x: 1e3 },
          ...t
        }
      ),
      L && /* @__PURE__ */ s.jsx("div", { className: "bitzTablePagination", children: /* @__PURE__ */ s.jsx(
        ns,
        {
          enableControl: K,
          pagination: D,
          total: d,
          dataSource: e,
          resetPage: q,
          paginationEmit: F
        }
      ) })
    ] }),
    z && /* @__PURE__ */ s.jsxs(s.Fragment, { children: [
      (x || (e == null ? void 0 : e.length) > 0) && /* @__PURE__ */ s.jsx(
        ls,
        {
          color: A,
          height: O,
          showNoMore: R,
          refreshEmit: u,
          loadEmit: k,
          extra: /* @__PURE__ */ s.jsxs("div", { className: "mobileTable", children: [
            e == null ? void 0 : e.map((l, n) => /* @__PURE__ */ s.jsxs("div", { children: [
              /* @__PURE__ */ s.jsx("div", { className: "rowBox", children: c == null ? void 0 : c.map((r, i) => /* @__PURE__ */ s.jsx("div", { children: !(r != null && r.mobileHide) && /* @__PURE__ */ s.jsxs(
                "div",
                {
                  className: "row",
                  onClick: () => {
                    U(l);
                  },
                  children: [
                    /* @__PURE__ */ s.jsxs("div", { className: "label", children: [
                      r.title,
                      "："
                    ] }),
                    /* @__PURE__ */ s.jsx("div", { className: "value", children: r.render(
                      xs(l, r == null ? void 0 : r.dataIndex),
                      l,
                      n
                    ) })
                  ]
                }
              ) }, i)) }),
              /* @__PURE__ */ s.jsx("div", { className: "rowBoxLine" })
            ] }, n)),
            x && Array.from({ length: T }).map((l, n) => /* @__PURE__ */ s.jsxs("div", { children: [
              /* @__PURE__ */ s.jsx("div", { className: "rowBox", children: j ? j() : /* @__PURE__ */ s.jsx(
                ss,
                {
                  title: !1,
                  paragraph: {
                    rows: C,
                    width: y
                  },
                  active: !0
                }
              ) }),
              /* @__PURE__ */ s.jsx("div", { className: "rowBoxLine" })
            ] }, n)),
            /* @__PURE__ */ s.jsx(
              es,
              {
                className: "tableMobileDrawer",
                open: G,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: v,
                children: /* @__PURE__ */ s.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ s.jsx("div", { className: "boxBody", children: E.map((l, n) => /* @__PURE__ */ s.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => {
                        X(l);
                      },
                      children: l.label
                    },
                    n
                  )) }),
                  /* @__PURE__ */ s.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ s.jsx("div", { className: "boxFooter", onClick: v, children: P })
                ] })
              }
            )
          ] })
        }
      ),
      !x && /* @__PURE__ */ s.jsx(is, { data: e, title: $, img: _ })
    ] })
  ] });
}, Ls = (h) => (
  // @ts-ignore
  /* @__PURE__ */ s.jsx(rs, { initValue: h, children: /* @__PURE__ */ s.jsx(cs, { ...h }) })
);
export {
  Ls as default
};
