import { j as s } from "../../../../node_modules/react/jsx-runtime.mjs";
import { create as G, useModal as H, antdModalV5 as J } from "@ebay/nice-modal-react";
import { Modal as P, Checkbox as Q } from "antd";
import t from "./index.module.less.mjs";
import { useState as U, useContext as X, useCallback as E, useMemo as j } from "react";
import { TableContext as Y } from "../../Store/index.mjs";
import { genColumnKey as K, columnSort as Z } from "../../Store/utils/index.mjs";
import A from "../../../../node_modules/classnames/index.mjs";
import { DndContext as _, DragOverlay as $, defaultDropAnimationSideEffects as ee } from "../../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { SortableContext as se, verticalListSortingStrategy as le, arrayMove as oe } from "../../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import te from "./DndItem.mjs";
import { restrictToVerticalAxis as ae, restrictToWindowEdges as ne } from "../../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import O from "../../../../node_modules/lodash-es/omit.mjs";
import ce from "../../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
import ie from "../../../../node_modules/@ant-design/icons/es/icons/DragOutlined.mjs";
const de = {
  sideEffects: ee({
    styles: {
      active: {
        opacity: "0.5"
      }
    }
  })
}, Me = G(() => {
  var D;
  const v = H(), C = J(v), [u, b] = U(null), {
    columnList: T,
    setColumnList: B,
    columnsMap: i,
    setColumnsMap: p,
    sortKeyColumns: x,
    setSortKeyColumns: R,
    clearPersistenceStorage: y,
    ...o
  } = X(Y), V = E(() => {
    y == null || y(), p(o.defaultColumnKeyMap);
  }, []), h = j(() => {
    var l, a;
    const e = [];
    return (l = o == null ? void 0 : o.columns) != null && l.length && ((a = o == null ? void 0 : o.columns) == null || a.map(({ key: m, dataIndex: n, ...d }) => {
      const f = K(
        m || n,
        [m || n].filter(Boolean).join("-")
      ), r = i[f || "null"];
      return (r == null ? void 0 : r.show) !== !1 && e.push({
        key: f,
        ...O(d, ["className"]),
        selectable: !1,
        disabled: (r == null ? void 0 : r.disable) === !0
      }), r;
    })), e.sort(Z(i));
  }, [i, o == null ? void 0 : o.columns]), N = E(
    (e) => x == null ? void 0 : x.findIndex((l) => l === e),
    [x]
  ), S = j(
    () => u ? N(u) : -1,
    [u, N]
  ), M = j(() => {
    const e = [], l = /* @__PURE__ */ new Map();
    return { list: ((m, n) => m.map(({ key: d, dataIndex: f, children: r, ...w }) => {
      var g;
      const k = K(
        d || f,
        [n == null ? void 0 : n.columnKey, w.index].filter(Boolean).join("-")
      ), c = i[k || "null"] || { show: !0 };
      (c == null ? void 0 : c.show) !== !1 && !r && e.push(k);
      const I = {
        key: k,
        ...O(w, ["className"]),
        selectable: !1,
        disabled: c.disable === !0,
        disableCheckbox: typeof c.disable == "boolean" ? c == null ? void 0 : c.disable : (g = c == null ? void 0 : c.disable) == null ? void 0 : g.checkbox,
        isLeaf: n ? !0 : void 0
      };
      return l.set(d, I), I;
    }))(o == null ? void 0 : o.columns), keys: e, map: l };
  }, [i, o == null ? void 0 : o.columns]), L = (e, l) => {
    const a = { ...i };
    ((n) => {
      const d = { ...a[n] };
      d.show = !e, a[n] = d;
    })(l.key), p({ ...a });
  }, W = (e, l) => {
    const a = { ...i }, m = oe(x, e, l);
    m.forEach((n, d) => {
      a[n] = { ...a[n] || {}, order: d };
    }), p(a), R(m);
  }, q = j(() => {
    var e, l;
    return u ? ((l = (e = o == null ? void 0 : o.columns) == null ? void 0 : e.find((a) => a.key === u)) == null ? void 0 : l.title) ?? "" : "";
  }, [o == null ? void 0 : o.columns, u, i, x]), z = () => {
    B({ ...i }), v.resolve({ ...i }), v.hide();
  }, F = () => {
    p({ ...T }), C.onCancel();
  };
  return /* @__PURE__ */ s.jsxs(
    P,
    {
      title: "自定义列",
      ...C,
      width: 600,
      onOk: z,
      onCancel: F,
      children: [
        /* @__PURE__ */ s.jsx("div", { className: t.introduce, children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }),
        /* @__PURE__ */ s.jsxs("div", { className: t.contaiern, children: [
          /* @__PURE__ */ s.jsxs("div", { className: t.block, children: [
            /* @__PURE__ */ s.jsxs("div", { className: t.header, children: [
              /* @__PURE__ */ s.jsx("div", { className: t.title, children: "可用列" }),
              /* @__PURE__ */ s.jsx("div", {})
            ] }),
            /* @__PURE__ */ s.jsx("div", { className: t.body, children: /* @__PURE__ */ s.jsx("ul", { className: t.content, children: (D = M.list) == null ? void 0 : D.map((e) => {
              const l = M.keys.includes(e.key);
              return /* @__PURE__ */ s.jsxs(
                "li",
                {
                  className: A(t.item, {
                    [t.checked]: !l
                  }),
                  onClick: () => !e.disabled && L(l, e),
                  children: [
                    /* @__PURE__ */ s.jsx(Q, { checked: l, disabled: e.disabled }),
                    /* @__PURE__ */ s.jsx("span", { className: t["content-item-text"], children: e.title })
                  ]
                },
                e.key
              );
            }) }) })
          ] }),
          /* @__PURE__ */ s.jsxs("div", { className: t.block, children: [
            /* @__PURE__ */ s.jsxs("div", { className: t.header, children: [
              /* @__PURE__ */ s.jsx("div", { className: t.title, children: "选定的列" }),
              /* @__PURE__ */ s.jsxs("div", { className: t.reset, onClick: V, children: [
                /* @__PURE__ */ s.jsx("div", { children: "重置  " }),
                /* @__PURE__ */ s.jsx(ce, {})
              ] })
            ] }),
            /* @__PURE__ */ s.jsx("div", { className: t.body, children: /* @__PURE__ */ s.jsxs(
              _,
              {
                modifiers: [ae, ne],
                onDragStart: (e) => {
                  const { active: l } = e;
                  l && b(l == null ? void 0 : l.id);
                },
                onDragCancel: () => b(null),
                onDragEnd: (e) => {
                  b(null);
                  const { over: l } = e;
                  if (l) {
                    const a = N(l.id);
                    S !== a && W(S, a);
                  }
                },
                children: [
                  /* @__PURE__ */ s.jsx(
                    se,
                    {
                      items: h == null ? void 0 : h.map((e) => e.key),
                      strategy: le,
                      children: /* @__PURE__ */ s.jsx("ul", { className: t.content, style: { background: "#fff" }, children: h == null ? void 0 : h.map((e) => /* @__PURE__ */ s.jsx(te, { item: e }, e.key)) })
                    }
                  ),
                  /* @__PURE__ */ s.jsx($, { adjustScale: !1, dropAnimation: de, children: u ? /* @__PURE__ */ s.jsxs("li", { className: A(t.moveItem), children: [
                    /* @__PURE__ */ s.jsx(ie, { className: t.dragIcon }),
                    /* @__PURE__ */ s.jsx("span", { className: t["moveItem-text"], children: q })
                  ] }) : null })
                ]
              }
            ) })
          ] })
        ] })
      ]
    }
  );
});
export {
  Me as default
};
